
#include "Study/newADVISEModelSetStudy/newADVISEModelSetStudySetStudy.h"

//******************************************************
//Global Variables
//******************************************************
Short userAuthStrength;
Char userAuthType;

//********************************************************
//newADVISEModelSetStudySetStudy Constructor
//********************************************************
newADVISEModelSetStudySetStudy::newADVISEModelSetStudySetStudy() {

  // add all of the experiment names
  mExperimentNames.emplace_back("StrongFirewalls");
  mExperimentNames.emplace_back("WeakFirewalls");
  // define arrays of global variable names and types
  NumGVs = 2;
  NumExps = 2;

  GVNames = new char*[NumGVs];
  GVTypes = new char*[NumGVs];
  GVNames[0]=strdup("userAuthStrength");
  GVTypes[0]=strdup("Short");
  GVNames[1]=strdup("userAuthType");
  GVTypes[1]=strdup("Char");

  // create the arrays to store the values of each gv
  userAuthStrengthValues = new short[NumExps];
  userAuthTypeValues = new char[NumExps];

  // call methods to assign values to each gv
  SetValues_userAuthStrength();
  SetValues_userAuthType();
  SetDefaultMobiusRoot(MOBIUSROOT);
}


//******************************************************
//newADVISEModelSetStudySetStudy Destructor
//******************************************************
newADVISEModelSetStudySetStudy::~newADVISEModelSetStudySetStudy() {
  delete [] userAuthStrengthValues;
  delete [] userAuthTypeValues;
  delete ThePVModel;
}


//******************************************************
// set values for userAuthStrength
//******************************************************
void newADVISEModelSetStudySetStudy::SetValues_userAuthStrength() {
  userAuthStrengthValues[0] = 8;
  userAuthStrengthValues[1] = 1;
}


//******************************************************
// set values for userAuthType
//******************************************************
void newADVISEModelSetStudySetStudy::SetValues_userAuthType() {
  userAuthTypeValues[0] = 'T';
  userAuthTypeValues[1] = 'W';
}



//******************************************************
//print values of gv (for debugging)
//******************************************************
void newADVISEModelSetStudySetStudy::PrintGlobalValues(int expNum) {
  if (NumGVs == 0) {
    cout<<"There are no global variables."<<endl;
    return;
  }

  SetGVs(expNum);

  cout<<"The Global Variable values for experiment "<<
    GetExpName(expNum)<<" are:"<<endl;
  cout << "userAuthStrength\tShort\t" << userAuthStrength << endl;
  cout << "userAuthType\tChar\t" << userAuthType << endl;
}


//******************************************************
//retrieve the value of a global variable
//******************************************************
void *newADVISEModelSetStudySetStudy::GetGVValue(char *TheGVName) {
  if (strcmp("userAuthStrength", TheGVName) == 0)
    return &userAuthStrength;
  else if (strcmp("userAuthType", TheGVName) == 0)
    return &userAuthType;
  else 
    cerr<<"!! newADVISEModelSetStudySetStudy::GetGVValue: Global Variable "<<TheGVName<<" does not exist."<<endl;
  return NULL;
}


//******************************************************
//override the value of a global variable
//******************************************************
void newADVISEModelSetStudySetStudy::OverrideGVValue(char *TheGVName,void *TheGVValue) {
  if (strcmp("userAuthStrength", TheGVName) == 0)
    SetGvValue(userAuthStrength, *(short *)TheGVValue);
  else if (strcmp("userAuthType", TheGVName) == 0)
    SetGvValue(userAuthType, *(char *)TheGVValue);
  else 
    cerr<<"!! newADVISEModelSetStudySetStudy::OverrideGVValue: Global Variable "<<TheGVName<<" does not exist."<<endl;
}


//******************************************************
//set the value of all global variables to the given exp
//******************************************************
void newADVISEModelSetStudySetStudy::SetGVs(int expNum) {
BaseStudyClass::SetGVs(expNum);
  SetGvValue(userAuthStrength, userAuthStrengthValues[expNum]);
  SetGvValue(userAuthType, userAuthTypeValues[expNum]);
}


//******************************************************
//static class method called by solvers to create study 
//(and thus create all of the model)
//******************************************************
BaseStudyClass* GlobalStudyPtr = NULL;
BaseStudyClass * GenerateStudy() {
  if (GlobalStudyPtr == NULL)
    GlobalStudyPtr = new newADVISEModelSetStudySetStudy();
  return GlobalStudyPtr;
}

void DestructStudy() {
  delete GlobalStudyPtr;
  GlobalStudyPtr = NULL;
}
//******************************************************
//get and create the PVModel
//******************************************************
PVModel* newADVISEModelSetStudySetStudy::GetPVModel(bool expandTimeArrays) {
  if (ThePVModel!=NULL)
    delete ThePVModel;
  // create the PV model
  ThePVModel=new newADVISEModelPVsPVModel(expandTimeArrays);
  return ThePVModel;
}


